package cn.com.infosec.crypto.tls;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class RecordStream {
   private TlsProtocolHandler handler;
   private InputStream is;
   private OutputStream os;
   protected CombinedHash hash1;
   protected CombinedHash hash2;
   protected TlsCipherSuite readSuite;
   protected TlsCipherSuite writeSuite;

   protected RecordStream(TlsProtocolHandler handler, InputStream is, OutputStream os) {
      RecordStream var10000 = this;
      RecordStream var10001 = this;
      RecordStream var10002 = this;
      RecordStream var10003 = this;
      super();
      this.readSuite = null;
      this.writeSuite = null;
      this.handler = handler;
      this.is = is;
      this.os = os;
      CombinedHash var4;
      var4 = new CombinedHash.<init>();
      var10003.hash1 = var4;
      var4 = new CombinedHash.<init>();
      var10002.hash2 = var4;
      TlsNullCipherSuite var5;
      var5 = new TlsNullCipherSuite.<init>();
      var10001.readSuite = var5;
      var10000.writeSuite = var5;
   }

   public void readData() {
      RecordStream var10000 = this;
      RecordStream var10001 = this;
      RecordStream var10002 = this;
      int var1 = TlsUtils.readUint8(this.is);
      TlsUtils.checkVersion(this.is, this.handler);
      int var2 = TlsUtils.readUint16(this.is);
      byte[] var4 = var10001.decodeAndVerify((short)var1, var10002.is, var2);
      TlsProtocolHandler var3 = var10000.handler;
      short var5 = (short)var1;
      var1 = var4.length;
      var3.processData(var5, var4, 0, var1);
   }

   protected byte[] decodeAndVerify(short type, InputStream is, int len) {
      byte[] var4;
      TlsUtils.readFully(var4 = new byte[len], is);
      TlsCipherSuite var10000 = this.readSuite;
      TlsProtocolHandler var5 = this.handler;
      return var10000.decodeCiphertext(type, var4, 0, len, var5);
   }

   protected void writeMessage(short type, byte[] message, int offset, int len) {
      if (type == 22) {
         this.hash1.update(message, offset, len);
         this.hash2.update(message, offset, len);
      }

      RecordStream var10000 = this;
      RecordStream var10001 = this;
      byte[] var10002 = this.writeSuite.encodePlaintext((short)type, message, offset, len);
      byte[] var5;
      TlsUtils.writeUint8((short)type, var5 = new byte[var10002.length + 5], 0);
      TlsUtils.writeUint8((short)3, var5, 1);
      TlsUtils.writeUint8((short)1, var5, 2);
      TlsUtils.writeUint16(var10002.length, var5, 3);
      type = var10002.length;
      System.arraycopy(var10002, 0, var5, 5, type);
      var10001.os.write(var5);
      var10000.os.flush();
   }

   protected void close() {
      RecordStream var10000 = this;
      IOException var1 = null;

      try {
         var10000.is.close();
      } catch (IOException var2) {
         var1 = var2;
      }

      IOException var4;
      label22: {
         try {
            this.os.close();
         } catch (IOException var3) {
            var4 = var3;
            break label22;
         }

         var4 = var1;
      }

      if (var4 != null) {
         throw var4;
      }
   }

   protected void flush() {
      this.os.flush();
   }
}
